#include <string.h>
#include <stdio.h>
#include <time.h>
#include "DirentParser.h"

// スペースで区切られた文字列を item 配列に分割
void strparse(char *str, char *item[], uint32 *itemCount)
{
	uint32 i = 0, cnt = *itemCount;
	char *p = str;
	
	while (true) {
		if (i >= cnt) break;
		for(; *p == ' '; p++);
		if (*p == 0) break;
		item[i] = p;
		i++;
		if (i >= cnt) break;
		for(; (*p != ' ') && (*p != 0); p++);
		if (*p == 0) break;
		*p = 0;
		p++;
	}
	*itemCount = i;
	for(; i < cnt; i++) item[i] = 0;
}

status_t TGenericDirentParser::AddEntries(const char *strDirList)
{
	status_t status = B_OK;
	BList list;
	BString strdir(strDirList);
	strdir.ReplaceAll("\r\n", "\n");
	strdir.ReplaceAll("\r", "\n");
	
	// ftpd から得た NLST 文字列 strDirList を各行に分割して list にポインタを記憶する
	char *p = (char *)strdir.String();
	while (*p != 0) {
		list.AddItem(p);
		p = strchr(p, '\n');
	    if (p == NULL) break;
		*p = 0;
		p++;
	}
	
	for(int32 i = 0; i < list.CountItems(); i++) {
		uint32 itemCount = 9;
		char *dlist[9];
		memset(dlist, 0, sizeof(dlist));
		p = (char *)list.ItemAt(i);
		strparse(p, dlist, &itemCount);
		if (itemCount != 9) continue;
		
		char *permission = dlist[0];
//		char *num        = dlist[1];
		char *owner      = dlist[2];
		char *group      = dlist[3];
		char *size       = dlist[4];
		char *month      = dlist[5];
		char *day        = dlist[6];
		char *houryear   = dlist[7];
		char *name       = dlist[8];
		
		// 日付・時間を変換
		BString strdate, strtime;
		if (atoi(houryear) < 1900) {
			char stryear[5];
			time_t timer;
			struct tm *date;
			time(&timer);
			date = localtime(&timer);
			strftime(stryear, sizeof(stryear), "%Y", date);
			strdate << stryear;
			strtime << " " << houryear;
		} else {
			strdate << houryear;
		}
		strdate << "/";
		if (strcasecmp("Jan", month) == 0) strdate << "01"; else
		if (strcasecmp("Feb", month) == 0) strdate << "02"; else
		if (strcasecmp("Mar", month) == 0) strdate << "03"; else
		if (strcasecmp("Apr", month) == 0) strdate << "04"; else
		if (strcasecmp("May", month) == 0) strdate << "05"; else
		if (strcasecmp("Jun", month) == 0) strdate << "06"; else
		if (strcasecmp("Jul", month) == 0) strdate << "07"; else
		if (strcasecmp("Aug", month) == 0) strdate << "08"; else
		if (strcasecmp("Sep", month) == 0) strdate << "09"; else
		if (strcasecmp("Oct", month) == 0) strdate << "10"; else
		if (strcasecmp("Nov", month) == 0) strdate << "11"; else
		if (strcasecmp("Dec", month) == 0) strdate << "12"; else strdate << month;
		char strday[3];
		sprintf(strday, "%2.2d", atoi(day));
		strdate << "/" << strday << strtime;
		
		// パーミッションを変換
		uint32 perm = 0;
		if (strlen(permission) == 10) {
			perm |= (permission[0] == 'd') ? 0x200 : 0;
			perm |= (permission[1] == 'r') ? 0x100 : 0;
			perm |= (permission[2] == 'w') ? 0x80  : 0;
			perm |= (permission[3] == 'x') ? 0x40  : 0;
			perm |= (permission[4] == 'r') ? 0x20  : 0;
			perm |= (permission[5] == 'w') ? 0x10  : 0;
			perm |= (permission[6] == 'x') ? 0x8   : 0;
			perm |= (permission[7] == 'r') ? 0x4   : 0;
			perm |= (permission[8] == 'w') ? 0x2   : 0;
			perm |= (permission[9] == 'x') ? 0x1   : 0;
		} else {
			perm = 0777;
		}
		
		// リストに追加
		status = this->AddEntry(name, atoi(size), strdate.String(), perm, owner, group);
		if (status != B_OK) break;
	}
	return status;
}
