#ifndef _FTPCLIENT_H
#define _FTPCLIENT_H

#include <String.h>
#include <sys/time.h>


class TFTPClient
{
public:
	TFTPClient();
	~TFTPClient();
	
	void Abort();
	uint32 Reply() const;
	const char *StrReply() const;
	const char *StrError() const;
	
	status_t Connect(const char *address, uint16 port);
	void Disconnect();
	
	status_t SetBlockingMode(bool wouldBlock);
	bool IsReceivable(long sec, long msec);
	
	status_t Readres(bigtime_t waitTime);
	status_t SendCmd(const char *command, uint32 commandLen);
	
	status_t USER(const char *userName);
	status_t PASS(const char *password);
	status_t PASV(struct sockaddr_in *addr);
	status_t NLST(struct sockaddr_in *addr, bool passive);
	status_t XPWD(BString *result);
	status_t CWD(const char *dir);
	
private:
	status_t Readline(BString *line, bigtime_t waitTime);
	
	volatile bool fAborted;
	uint32 fReply;
	BString fStrReply;
	BString fStrError;
	BString fPendingString;
	int fControlEndpoint;
	bigtime_t fWaitTime;
};

#endif
