#ifndef _TCPSTREAM_H_
#define _TCPSTREAM_H_

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
#include <DataIO.h>
#include <SupportDefs.h>


class TTCPStream
{
public:
	TTCPStream(BDataIO *dataIO, struct sockaddr_in *addr, bigtime_t waitTime);
	~TTCPStream();
	status_t Result() const { return fStatus; };
	void Abort();
private:
	bool IsReceivable(long sec, long msec);
	static int32 ReceiveFunc(void *self);
	thread_id fThreadID;
	status_t fStatus;
	volatile bool fAborted;
	BDataIO *fDataIO;
	int fEndpoint;
	bigtime_t fWaitTime;
};


#endif
